//########################
//InDesignCS3に画像を配置していきます。
//右ページ、左ページ個別にフレームサイズを指定する事ができ、
//さらに画像の配置時の空きも右ページ、左ページ個別に設定できます。
//ドキュメントを開いて実行してください。
//たけうちとおる
//########################


//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;
////////下記が初期値になりますので編集してください。//////////

//配置ファイル番号
var startfile = 0;
//配置ファイル番号
var endfile = 0;
//左ページ画像の水平パーセント
var l_myPerW = 100;
//左ページ画像の垂直パーセント
var l_myPerH = 100;
//全ファイル配置
var myconfirmflg = true;

main();
function main(){
	if (app.documents.length == 0){
			alert("ドキュメントを開いて実行してください。");
			return;
	}
	//ダイアログを作成する
	myDialog = app.dialogs.add({name:"画像をInDesignの選択ページに配置します。"});
	with(myDialog){
		with(dialogColumns.add()){

			with(borderPanels.add()){
				with (dialogColumns.add()){
					with (dialogRows.add()){
						//staticTexts.add({staticLabel:"画像の配置方法"});
						var confirmflg = checkboxControls.add({staticLabel:"全ファイルを配置", checkedState:myconfirmflg})
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"配置スタートファイル番号"});
						var d_startfile = integerEditboxes.add({editValue:startfile,minimumValue:0,maximumValue:100000});
						staticTexts.add({staticLabel:"以上"});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"配置終了ファイル番号"});
						var d_endfile = integerEditboxes.add({editValue:endfile,minimumValue:0,maximumValue:100000});
						staticTexts.add({staticLabel:"未満"});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"画像の配置方法"});
					}
					with (dialogRows.add()){
						var Listpercent = new Array("100", "90", "80", "70", "60", "50", "40", "30", "20", "10", "0");
						staticTexts.add({staticLabel:"Wの変倍率"});
						var d_l_myPerW = percentComboboxes.add({editValue:l_myPerW,minimumValue:0,maximumValue:1000,stringList:Listpercent});
					}
					with (dialogRows.add()){
						staticTexts.add({staticLabel:"Hの変倍率"});
						var d_l_myPerH = percentComboboxes.add({editValue:l_myPerH,minimumValue:0,maximumValue:1000,stringList:Listpercent});
					}
				}
			}
			staticTexts.add({staticLabel:"(C)2009 Toru Takeuchi このスクリプトはフリーウェアです。"});
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		l_myPerW = d_l_myPerW.editValue;
		l_myPerH = d_l_myPerH.editValue;
		startfile = d_startfile.editValue;
		endfile = d_endfile.editValue;
		myconfirmflg = confirmflg.checkedState;
		myDialog.destroy();
		indd_select_img();
		alert("配置が終了しました。");
	}
	else{
		myDialog.destroy();
	}
}

function indd_select_img(){
	if (app.documents.length != 0){
		var folderObj = getfolder();
		fileList = folderObj.getFiles();
		var pageB= app.activeDocument.pages[0].bounds;
		var myY = 0;
		var myMoveH = pageB[3]/(endfile - startfile)
		var putCount = 1;
		for(var N=0;N<fileList.length;N++){
			var selFile = fileList[N];
			if(selFile.hidden == false){
				if(myconfirmflg){
						var objY = placeimg(selFile,myY);
						myY = myY + myMoveH;
						if(objY < myY){myY = objY;}
				}else{
					if(startfile <= putCount && putCount < endfile){
						var objY = placeimg(selFile,myY);
						myY = myY + myMoveH;
						if(objY < myY){myY = objY;}
					}
					putCount++;
					if(putCount >= endfile){
						return;
					}
				}
			}
		}
	}
}
//フォルダ選択ダイアログ
function getfolder(){
	var folderobj = Folder.selectDialog("画像が入ったフォルダを選択してください");
	return folderobj;
}
function placeimg(selFile,myY){
	//app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_CONTENT;	//1131573315	バウンディングボックス
	app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_ART;//アート
	//app.pdfPlacePreferences.pdfCrop = PDFCrop.ROP_PDF;//	1131573328	トリミング
	//app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_TRIM;//	1131573332	トンボ
	//app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_BLEED;//	1131573314	裁ち落とし
	//app.pdfPlacePreferences.pdfCrop = PDFCrop.CROP_MEDIA;//	1131573325	メディア
	
	pageObj = app.activeWindow.activePage;
	var rectObj = pageObj.rectangles.add();
	rectObj.strokeWeight = 0;
	
	var rectbounds = rectObj.geometricBounds;
	rectbounds[0]=rectbounds[0]+myY;
	rectbounds[1]=rectbounds[1];
	rectbounds[2]=rectbounds[2]+myY;
	rectbounds[3]=rectbounds[3];
	rectObj.geometricBounds = rectbounds;	
	
	
	var pdfobj = rectObj.place(selFile);
	rectObj.allGraphics[0].verticalScale = l_myPerH;
	rectObj.allGraphics[0].horizontalScale = l_myPerW;
	rectObj.fit (FitOptions.FRAME_TO_CONTENT);
	//rectObj.fit (FitOptions.CENTER_CONTENT);	
	var rectbounds = rectObj.geometricBounds;
	return rectbounds[2];
}